angular.module('starter.directives')

  .directive('tfPhotoThumbnail', [function() {
    return {
      template: '<span class="crop"><img ng-show="loaded" src="{{ path }}"><span class="uploading" ng-show="uploading"><i class="ion-loading-c"></i></span></span>',
      scope: { path: '=', uploading: '=' },
      restrict: 'E',
      link: function($scope, $element, $attrs) {
        $scope.loaded = false;

        var img = $element[0].getElementsByTagName('img')[0];
        var cropContainer = img.parentNode;
        var container = cropContainer.parentNode;

        var path = $scope.path;

        img.onerror = function(err) {
          //cropContainer.innerHTML = '<i class="icon ion-image"></i>';
          //cropContainer.innerHTML = 'err';
          container.className += ' error-loading';
        };
        img.onload = function() {
          $scope.loaded = true;
          $scope.$apply();

          setTimeout(function() {
            var w = img.width;
            var h = img.height;

            if (w > h) {
              img.style.height = '100%';
              img.style.marginLeft = -Math.round((w-h)/h/2*100) + '%';
            }
            else {
              img.style.width = '100%';
              img.style.marginTop = -Math.round((h-w)/w/2*100) + '%';
            }
          }, 13)
        };

        img.src = 'http://ep1.pinkbike.org/p0pb11922308/p0pb11922308.jpg';
      },
    }
  }]);
